/*
    FEARLUS model0-7: ClassInfo.h
    Copyright (C) 1999-2003  Macaulay Institute

    This file is part of FEARLUS model0-7, an agent-based model of land use
    change.

    FEARLUS model0-7 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-7 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


This is the interface for the ClassInfo class -- a global object class
initialised in main.m. It creates a list of classes in the simulation, and
can be called to fill out a list of classes that follow a particular protocol.
Its interface consists of class methods only, with the initialise method used
to create the single static instance accessible only within the implementation
code. It can then be accessed globally through the class methods by calling
the class. This is really an underhanded OO way of getting a global variable.

ClassInfo stores a list of all the classes in the simulation, and can then be
used to find a list of classes that follow a particular protocol.

*/

#import <objectbase/SwarmObject.h>
#import <objc/Protocol.h>
#import <collections/List.h>
#import <defobj/Zone.h>

@interface ClassInfo: SwarmObject {
  id <List> cl;
}

+(void)initialise: (id <Zone>)aZone;	/* Should be constructed in its own
					   zone */
+(void)getClassesForProtocol: (Protocol *)p inList: (id <List>)li;
+(void)getSubClassesOfClass: (Class)c inList: (id <List>)li;
+(BOOL)class: (Class)c1 isSubClassOf: (Class)c2;

@end
